## POS tags, NER types and dependency labels in VnCoreNLP

The following sections are to briefly describe  [POS tags](https://github.com/vncorenlp/VnCoreNLP/blob/master/VLSP2013_POS_tagset.pdf), [NER types](http://vlsp.org.vn/vlsp2016/eval/ner) and [dependency labels](https://github.com/vncorenlp/VnCoreNLP/blob/master/VnDT-treebank-description.pdf) used in VnCoreNLP. See details in [Link-to-POS-tag-description](https://github.com/vncorenlp/VnCoreNLP/blob/master/VLSP2013_POS_tagset.pdf), [Link-to-NER-type-description](http://vlsp.org.vn/vlsp2016/eval/ner) and [Link-to-dependency-label-description](https://github.com/vncorenlp/VnCoreNLP/blob/master/VnDT-treebank-description.pdf).  

### POS tags

|Label| Meaning  |
|---|---|
| Np | Proper noun |
| Nc | Classifier noun | 
| Nu | Unit noun | 
| N | Noun | 
| Ny | Abbreviated noun | 
| Nb | (Foreign) borrowed noun|
| V | Verb| 
|Vb |(Foreign) borrowed verb|
|A| Adjective|
|P| Pronoun|
|R |Adverb|
|L| Determiner|
|M |Numeral/Quantity|
|E |Preposition|
|C |Subordinating conjunction|
|Cc |Coordinating conjunction|
|I |Interjection/Exclamation|
|T |Particle/Auxiliary, modal words|
|Y |Abbreviation|
|Z |Bound morpheme|
|X |Un-definition/Other|
|CH |Punctuation and symbols|

### NER types

|Label| Meaning  |
|---|---|
| PER | Names of persons |
| LOC | Names of locations | 
| ORG| Names of organizations| 
| MISC|Names of miscellaneous entities|

### Top 21 most frequent dependency labels

These following labels has an appearance rate of at least 0.2%:

|Label| Meaning  |
|---|---|
|adv|Adverbial | 
|amod| Adjective modifier |
|conj| Conjunction |
|coord| Coordination |
|dep| Default label |
|det| Determiner |
|dir| Direction |
|dob| Direct object |
|iob| Indirect object |
|loc| Location |
|mnr| Manner |
|nmod| Noun modifier |
|pmod| Prepositional  modifier |
|pob| Object of a preposition |
|prd| Predicate |
|prp| Purpose |
|punct| Punctuation |
|root| Root |
|sub| Subject |
|tmp|Temporal|
|vmod| Verb modifier |
